{-# OPTIONS_HADDOCK show-extensions #-}

-- |
-- Module      :  Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG2
-- Copyright   :  (c) OleksandrZhabenko 2020-2021
-- License     :  MIT
-- Stability   :  Experimental
-- Maintainer  :  olexandr543@yahoo.com
--
-- Generalization of the functionality of the DobutokO.Poetry.Norms
-- and DobutokO.Poetry.Norms.Extended modules
-- from the @dobutokO-poetry@ package. Instead of vectors, uses arrays.

{-# LANGUAGE CPP, BangPatterns #-}

module Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG2 (
  -- * Functions with 'Int16'
  procDiverse2I
  -- * Functions with 'Double'
  -- ** More general
  , procB2FG
  , procB2InvFG
  -- ** Usual ones
  , procDiverse2F
  , procBothF
  , procBothFF
  , procBothInvF
  , procBothInvFF
  -- ** Working with generated by r-glpk-phonetic-languages-ukrainian-durations syllable durations
  , procBoth2F
  , procBoth2FF
  , procBoth2InvF
  , procBoth2InvFF
  -- ** NEW Working with generated by r-glpk-phonetic-languages-ukrainian-durations syllable durations
  , procBoth3F
  , procBoth3FF
  , procBoth3InvF
  , procBoth3InvFF
  , procBoth4F
  , procBoth4FF
  , procBoth4InvF
  , procBoth4InvFF
  -- * Working with rhythmicity
  , procRhythmicity23F
  -- ** Working with rhythmicity that can be defined by the user (using 'rhythmicityH')
  , procRhythmicity23FH
) where

import Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG2Common
import Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG2Diverse
import Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG2Rhythmicity
import Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG21
import Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG22
import Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG23
import Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG24
